de.caff.generics

## Interface ByteIndexable

- All Superinterfaces:
    java.lang.Iterable<java.lang.Byte>, PrimitiveByteIterable, Sizeable
  All Known Subinterfaces:
    MutableByteIndexable
  All Known Implementing Classes:
    ByteIndexable.Base, BytePair, MutableByteIndexable.Base

      public interface ByteIndexable
      extends PrimitiveByteIterable, Sizeable

  Class which allows readonly access of raw bytes by index.

  The `EMPTY` constant or `emptyIndexable()` method provide the same useful return value to indicate emptiness.

  Simple implementations should extend `ByteIndexable.Base` because that provides useful implementations for standard Object methods and implements `Comparable`.

  Since:
    July 7, 2020
  Author:
    Rammi
  See Also:
    `FastByteSequenceSearch`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `ByteIndexable.Base` Abstract base class which provides useful implementations for `Object.equals(Object)`, `Object.hashCode()`, `Object.toString()`.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ByteIndexable.Base` | `EMPTY` An empty indexable.
    `static Indexable<java.lang.String>` | `LOWERCASE_2DIGIT_HEXCODES` Indexable with the 256 hexadecimal 2-digit codes for the (unsigned) byte values defined by the index (lowercase).
    `static ByteIndexable` | `SINGLE_0` Byte indexable with only one element with value 0.
    `static Indexable<java.lang.String>` | `UPPERCASE_2DIGIT_HEXCODES` Indexable with the 256 hexadecimal 2-digit codes for the (unsigned) byte values defined by the index (uppercase).

    - ### Fields inherited from interface de.caff.generics.PrimitiveByteIterable

      `EMPTY_BYTE_ITERATOR`

    - ### Fields inherited from interface de.caff.generics.Sizeable

      `NULL`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `addAllTo(java.util.Collection<? super java.lang.Byte> collection)` Add all elements of this indexable to the given collection.
    `default int` | `addToArray(byte[] array, int pos)` Add the content of this indexable to the given array.
    `default int` | `addToArray(byte[] array, int arrayPos, int index, int length)` Add a part of the content of this indexable to the given array.
    `default int` | `addToArray(int[] array, int pos)` Add the content of this indexable to the given int array.
    `default int` | `addToArray(int[] array, int arrayPos, int index, int length)` Add a part of the content of this indexable to the given intarray.
    `default ByteIndexable.Base` | `asBase()` Make this byte indexable usable as a class with defined standard Object methods.
    `default java.util.Collection<java.lang.Byte>` | `asCollection()` Get a view on this indexable as an unmodifiable collection.
    `default Indexable<java.lang.Byte>` | `asIndexable()` Get a view of this indexable as a standard object-based indexable.
    `default IntIndexable.Base` | `asIntIndexable()` View this byte indexable as an integer indexable.
    `default java.util.List<java.lang.Byte>` | `asList()` Get a view on this indexable as an unmodifiable list.
    `default IntIndexable.Base` | `asUnsignedIndexable()` View this byte indexable as an integer indexable using unsigned values.
    `default int` | `binarySearch(byte value)` Do a binary search in an indexable ordered in natural ascending order.
    `default int` | `binarySearch(byte value, ByteOrdering order)` Do a binary search in an ordered indexable.
    `default PrimitiveByteIterator` | `byteIterator()` Get an primitive byte iterator.
    `default PrimitiveByteIterator` | `byteIterator(int from, int to)` Get a byte iterator from the given sub set.
    `static byte[]` | `bytesFromHexString(java.lang.String hexString)` Get a byte array from a string of hexcoded bytes.
    `static int` | `compare(ByteIndexable indexable1, ByteIndexable indexable2)` Compare two byte indexables.
    `static int` | `compareUnsigned(ByteIndexable indexable1, ByteIndexable indexable2)` Compare two byte indexables as if they contain unsigned byte values.
    `default void` | `copyTo(byte[] targetArray, int targetStart)` Copy the content of this indexable into a byte array.
    `default void` | `copyTo(byte[] targetArray, int targetStart, int sourceStart, int length)` Copy the content of this indexable (or a part of it) into a byte array.
    `static ByteIndexable.Base` | `emptyIndexable()` Get an empty indexable set.
    `static boolean` | `equal(ByteIndexable indexable1, ByteIndexable indexable2)` Are two byte indexables equal?
    `static boolean` | `equal(ByteIndexable indexable1, java.lang.Object indexable2)` Are two byte indexables equal?
    `default int` | `firstMatch(BytePredicate1 check)` Get the first index for which the given check is fulfilled.
    `default byte` | `foldLeft(byte initialValue, ByteOperator2 foldOperation)` Go over all values and do a cumulative calculation.
    `static ByteIndexable` | `fromHexString(java.lang.String hexString)` Get a byte indexable from a string of hexcoded bytes.
    `default ByteIndexable` | `frozen()` Get a frozen version of this indexable.
    `byte` | `get(int index)` Get the element at the given index.
    `default byte` | `getMod(int index)` Get an element modulo size.
    `default byte` | `gyt(int index)` Pythonesque get.
    `static int` | `hash(ByteIndexable indexable)` Calculate a hashcode for a byte indexable.
    `default ByteIndexable.Base` | `headSet(int toIndex)` Create an indexable subset from the last elements of this indexable set.
    `default java.lang.Iterable<java.lang.Integer>` | `indexes()` Get the indexes of this indexable as an iterable range.
    `static ByteIndexable.Base` | `init(int size, byte value)` Get a byte indexable of a given size which always returns the same value.
    `static ByteIndexable` | `initByIndex(int size, IntToByteFunction1 producer)` Get a byte indexable of a given size which returns elements created by index.
    `default IntIndexable` | `intIndexes()` Get the indexes of this indexable as an integer indexable.
    `default java.util.PrimitiveIterator.OfInt` | `intIterator()` Get a primitive int iterator.
    `default boolean` | `isEmpty()` Is this indexable empty?
    `default boolean` | `isOrdered()` Is this indexable sorted naturally?
    `default boolean` | `isOrdered(ByteOrdering order)` Is this indexable sorted according to the given ordering?
    `default boolean` | `isStrictlyOrdered()` Is this indexable strictly sorted naturally?
    `default boolean` | `isStrictlyOrdered(ByteOrdering order)` Is this indexable strictly sorted according to the given ordering?
    `default java.util.Iterator<java.lang.Byte>` | `iterator()` Returns an iterator over elements of type `T`.
    `default int` | `lastMatch(BytePredicate1 check)` Get the last index for which the given check is fulfilled.
    `default java.util.ListIterator<java.lang.Byte>` | `listIterator()` Returns a list iterator over elements of type `T`.
    `default int` | `nextMatch(int startIndex, BytePredicate1 check)` Get the next index for which the given check is fulfilled.
    `default MutableByteIndexable` | `ordered(ByteOrdering order)` Create a (mutable) byte indexable from the values of this indexable which is ordered as defined by the given ordering.
    `default int` | `previousMatch(int startIndex, BytePredicate1 check)` Get the previous index for which the given check is fulfilled.
    `default ByteIndexable.Base` | `reverse()` Get this indexable but with inverted order.
    `default ByteIndexable` | `rotated(int steps)` Get a rotated view of this byte indexable.
    `static ByteIndexable.Base` | `singleton(byte value)` View a single byte value as a byte indexable of size 1.
    `default ByteIndexable.Base` | `subSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default ByteIndexable.Base` | `sybSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default ByteIndexable.Base` | `tailSet(int fromIndex)` Create an indexable subset from the last elements of this indexable set.
    `default byte[]` | `toArray()` Convert this indexable into a Java array.
    `default byte[]` | `toByteArray()` Get a byte array copy of this byte indexable.
    `default java.lang.String` | `toHexString()` Convert this byte indexable into a string of hexadecimal numbers, 2 per byte, using uppercase.
    `default java.lang.String` | `toHexString(boolean uppercase)` Convert this byte indexable into a string of hexadecimal numbers, 2 per byte.
    `default int[]` | `toIntArray()` Convert this indexable into an int array.
    `default java.util.ArrayList<java.lang.Byte>` | `toList()` Create a list from this bye indexable.
    `static java.lang.String` | `toString(ByteIndexable indexable)` Create a string representation of the given indexable.
    `default <T> Indexable<T>` | `view(ByteFunction1<? extends T> mapper)` Return a mapped view on this BYTE indexable.
    `static ByteIndexable.Base` | `viewArray(byte... array)` View a byte array as an Indexable.
    `static ByteIndexable.Base` | `viewArray(byte[] array, int start, int length)` View part of a byte array as an Indexable.
    `static <T> ByteIndexable.Base` | `viewArray(T[] array, ToByteFunction<? super T> valueExtract)` View an object array as a byte indexable.
    `default BooleanIndexable` | `viewAsBoolean(BytePredicate1 convert)` View this indexable as a boolean indexable while using a conversion for each value.
    `default DoubleIndexable` | `viewAsDouble()` View this byte integer indexable as a double indexable.
    `default FloatIndexable` | `viewAsFloat()` View this byte integer indexable as a float indexable.
    `default IntIndexable` | `viewAsInt()` View this byte integer indexable as an integer indexable.
    `default LongIndexable` | `viewAsLong()` View this byte integer indexable as a long integer indexable.
    `default ShortIndexable` | `viewAsShort()` View this byte integer indexable as a short integer indexable.
    `default IntIndexable` | `viewAsUnsignedInt()` View this byte integer indexable as an unsigned integer indexable.
    `default LongIndexable` | `viewAsUnsignedLong()` View this byte integer indexable as an unsigned long integer indexable.
    `default ShortIndexable` | `viewAsUnsignedShort()` View this byte integer indexable as an unsigned short integer indexable.
    `static ByteIndexable.Base` | `viewByIndex(int size, IntToByteFunction1 producer)` Get a byte indexable of a given size which returns elements created by index.
    `static ByteIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable)` View a generic Number indexable as byte indexable.
    `static ByteIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable, byte nullFallback)` View a generic Number indexable as byte indexable.
    `static <T> ByteIndexable.Base` | `viewIndexable(Indexable<T> indexable, ToByteFunction<? super T> extractor)` View a generic indexable as a byte indexable.
    `static ByteIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list)` View a list as an Indexable.
    `static ByteIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list, byte nullValue)` View a list as an Indexable.
    `static <T> ByteIndexable.Base` | `viewList(java.util.List<T> list, ToByteFunction<? super T> extractor)` View a generic list as a double indexable.
    `static ByteIndexable.Base` | `viewNumberArray(java.lang.Number... array)` View a Number array as an Indexable.
    `default ByteIndexable` | `viewOp(ByteOperator1 op)` View this byte indexable transformed by an operator.
    `default ByteIndexable` | `withAppendedValue(byte value)` Create a view with of this indexable with another value added at the end.
    `static ByteIndexable.Base` | `withCachedHash(ByteIndexable indexable)` Wrap an indexable with one which caches the hash value.
    `default ByteIndexable` | `withExchangedValueAt(int index, byte value)` Create a view of this byte indexable with an exchanged value.
    `default ByteIndexable` | `withInsertedValueAt(int index, byte value)` Create a view of this byte indexable with an inserted value.
    `default ByteIndexable` | `withRemovedValueAt(int index)` Create a view of this indexable with one value removed.
    `default ByteIndexable` | `withSwappedValuesAt(int index1, int index2)` Create a view of this byte indexable with two values swapped.

    - ### Methods inherited from interface de.caff.generics.PrimitiveByteIterable

      `asIntIterable, asLongIterable, asShortIterable, asUnsignedIntIterable, asUnsignedLongIterable, containsByte, forEachByte, forEachByteFragile`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface de.caff.generics.Sizeable

      `size`

- - ### Field Detail

    - #### SINGLE_0

          static final ByteIndexable SINGLE_0

      Byte indexable with only one element with value 0.

    - #### UPPERCASE_2DIGIT_HEXCODES

          static final Indexable<java.lang.String> UPPERCASE_2DIGIT_HEXCODES

      Indexable with the 256 hexadecimal 2-digit codes for the (unsigned) byte values defined by the index (uppercase).

    - #### LOWERCASE_2DIGIT_HEXCODES

          static final Indexable<java.lang.String> LOWERCASE_2DIGIT_HEXCODES

      Indexable with the 256 hexadecimal 2-digit codes for the (unsigned) byte values defined by the index (lowercase).

    - #### EMPTY

          static final ByteIndexable.Base EMPTY

      An empty indexable.

  - ### Method Detail

    - #### get

          byte get(int index)

      Get the element at the given index.
      Parameters:
        `index` - index between `0` and `size() - 1`
      Returns:
        element at the given index

    - #### gyt

          default byte gyt(int index)

      Pythonesque get. This allows accessing elements from the back by using negative indexes, e.g. `-1` references the last element, `-2` its predecessor, and so on.
      Parameters:
        `index` - index between `-size()` and `size() - 1`
      Returns:
        element at the given index

    - #### getMod

          default byte getMod(int index)

      Get an element modulo size.

      This maps the given `index` into the range of this indexable by applying a modulo `Sizeable.size()` operation. For empty indexable this will throw an `IndexOutOfBoundsException` as there is no possible index to get.

      Parameters:
        `index` - index, possibly out of range, possibly even negative for Pythonesque access
      Returns:
        element at the given, possibly modulated, index

    - #### reverse

          @NotNull
          default ByteIndexable.Base reverse()

      Get this indexable but with inverted order.
      Returns:
        a view to this indexable which accesses the elements in reverse order

    - #### isEmpty

          default boolean isEmpty()

      Is this indexable empty?
      Returns:
        `true`: there are no elements in this indexable
        `false`: this indexable has elements

    - #### intIterator

          @NotNull
          default java.util.PrimitiveIterator.OfInt intIterator()

      Get a primitive int iterator.
      Returns:
        `int` iterator which iterates over this indexable

    - #### byteIterator

          @NotNull
          default PrimitiveByteIterator byteIterator()

      Get an primitive byte iterator.
      Specified by:
        `byteIterator` in interface `PrimitiveByteIterable`
      Returns:
        `byte` iterator which iterates over this indexable

    - #### byteIterator

          @NotNull
          default PrimitiveByteIterator byteIterator(int from,
                                                              int to)

      Get a byte iterator from the given sub set.
      Parameters:
        `from` - first index of iterator
        `to` - one past last index of iterator
      Returns:
        int iterator which iterates over the given part of this indexable

    - #### iterator

          @NotNull
          default java.util.Iterator<java.lang.Byte> iterator()

      Returns an iterator over elements of type `T`.
      Specified by:
        `iterator` in interface `java.lang.Iterable<java.lang.Byte>`
      Specified by:
        `iterator` in interface `PrimitiveByteIterable`
      Returns:
        an Iterator.

    - #### listIterator

          @NotNull
          default java.util.ListIterator<java.lang.Byte> listIterator()

      Returns a list iterator over elements of type `T`.
      Returns:
        a list iterator.

    - #### subSet

          @NotNull
          default ByteIndexable.Base subSet(int fromIndex,
                                                     int toIndex)

      Get an indexable subset. The subset includes indices `fromIndex` to `toIndex - 1`.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - index after last index
      Returns:
        indxable subset view of this indexable

    - #### sybSet

          @NotNull
          default ByteIndexable.Base sybSet(int fromIndex,
                                                     int toIndex)

      Get an indexable subset. This is the Pythonesque version which allows negative indexes.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - end index of sub set
      Returns:
        indexable subset view of this indexable set

    - #### tailSet

          @NotNull
          default ByteIndexable.Base tailSet(int fromIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `fromIndex` - index to start with, negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### headSet

          @NotNull
          default ByteIndexable.Base headSet(int toIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `toIndex` - index one after the end (equal to the length of the returned set), negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### view

          @NotNull
          default <T> Indexable<T> view(@NotNull
                                                 ByteFunction1<? extends T> mapper)

      Return a mapped view on this BYTE indexable.
      Type Parameters:
        `T` - result type pf mapper
      Parameters:
        `mapper` - mapper
      Returns:
        mapped indexable

    - #### asCollection

          @NotNull
          default java.util.Collection<java.lang.Byte> asCollection()

      Get a view on this indexable as an unmodifiable collection. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view

    - #### asList

          @NotNull
          default java.util.List<java.lang.Byte> asList()

      Get a view on this indexable as an unmodifiable list. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view
      See Also:
        `toList()`

    - #### toList

          @NotNull
          default java.util.ArrayList<java.lang.Byte> toList()

      Create a list from this bye indexable. This creates an independent list to which the elements of this indexable are copied.
      Returns:
        list copy of this indexable
      See Also:
        `asList()`

    - #### addAllTo

          default void addAllTo(@NotNull
                                java.util.Collection<? super java.lang.Byte> collection)

      Add all elements of this indexable to the given collection.
      Parameters:
        `collection` - collection to add to

    - #### asIndexable

          @NotNull
          default Indexable<java.lang.Byte> asIndexable()

      Get a view of this indexable as a standard object-based indexable.
      Returns:
        indexable with non-null `Byte` values

    - #### toArray

          @NotNull
          default byte[] toArray()

      Convert this indexable into a Java array.
      Returns:
        array copy containing all values of this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 byte[] array,
                                 int pos)

      Add the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `pos` - position in the array where the content of this indexable is added
      Returns:
        array position after this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 byte[] array,
                                 int arrayPos,
                                 int index,
                                 int length)

      Add a part of the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `arrayPos` - position in hte array where the content is added
        `index` - start index of this indexable which is added first
        `length` - number of entries of this indexable added to the array
      Returns:
        array position after the added content

    - #### toIntArray

          @NotNull
          default int[] toIntArray()

      Convert this indexable into an int array.
      Returns:
        array copy containing all values of this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 int[] array,
                                 int pos)

      Add the content of this indexable to the given int array.
      Parameters:
        `array` - array where the content is added
        `pos` - position in the array where the content of this indexable is added
      Returns:
        array position after this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 int[] array,
                                 int arrayPos,
                                 int index,
                                 int length)

      Add a part of the content of this indexable to the given intarray.
      Parameters:
        `array` - array where the content is added
        `arrayPos` - position in hte array where the content is added
        `index` - start index of this indexable which is added first
        `length` - number of entries of this indexable added to the array
      Returns:
        array position after the added content

    - #### indexes

          @NotNull
          default java.lang.Iterable<java.lang.Integer> indexes()

      Get the indexes of this indexable as an iterable range.
      Returns:
        iterable indexes
      See Also:
        `intIndexes()`, `Range.indexes(int)`

    - #### intIndexes

          @NotNull
          default IntIndexable intIndexes()

      Get the indexes of this indexable as an integer indexable.
      Returns:
        indexes as integer indexable
      See Also:
        `indexes()`, `IntIndexable.rangeFromSize(int)`

    - #### asIntIndexable

          @NotNull
          default IntIndexable.Base asIntIndexable()

      View this byte indexable as an integer indexable.
      Returns:
        integer indexable view

    - #### asUnsignedIndexable

          @NotNull
          default IntIndexable.Base asUnsignedIndexable()

      View this byte indexable as an integer indexable using unsigned values.
      Returns:
        integer indexable view

    - #### toByteArray

          @NotNull
          default byte[] toByteArray()

      Get a byte array copy of this byte indexable.
      Returns:
        byte array

    - #### copyTo

          default void copyTo(@NotNull
                              byte[] targetArray,
                              int targetStart)

      Copy the content of this indexable into a byte array.
      Parameters:
        `targetArray` - target byte array
        `targetStart` - start index in target

    - #### copyTo

          default void copyTo(@NotNull
                              byte[] targetArray,
                              int targetStart,
                              int sourceStart,
                              int length)

      Copy the content of this indexable (or a part of it) into a byte array.
      Parameters:
        `targetArray` - target byte array
        `targetStart` - start index in target
        `sourceStart` - start index in this indexable
        `length` - number of bytes to be copied

    - #### foldLeft

          default byte foldLeft(byte initialValue,
                                @NotNull
                                ByteOperator2 foldOperation)

      Go over all values and do a cumulative calculation.
      Parameters:
        `initialValue` - start value for the operation, will be returned if this iterable is empty
        `foldOperation` - operation applied to each value, will get the accumulated value as its first and the current element value as its second argument
      Returns:
        accumulated value, result of applying fold operation to all values of this indexable iteratively

    - #### toHexString

          @NotNull
          default java.lang.String toHexString()

      Convert this byte indexable into a string of hexadecimal numbers, 2 per byte, using uppercase.
      Returns:
        hexadecimal string
      See Also:
        `toHexString(boolean)`

    - #### toHexString

          @NotNull
          default java.lang.String toHexString(boolean uppercase)

      Convert this byte indexable into a string of hexadecimal numbers, 2 per byte.
      Parameters:
        `uppercase` - if `true` the returned string will use uppercase letters for non-decimal digits
        if `false` it will use lowercase letters
      Returns:
        hexadecimal string

    - #### withInsertedValueAt

          @NotNull
          default ByteIndexable withInsertedValueAt(int index,
                                                             byte value)

      Create a view of this byte indexable with an inserted value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are inserted. Use `ExpandableIntIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable might result in a disaster when using the returned indexable!

      Parameters:
        `index` - index where the value is inserted before the current index (not Pythonesque, because it is possible to add an value at `index == size()`, and it is expected that most insertion will happen at 0 or at the end)
        `value` - inserted value at that index
      Returns:
        a view of this indexable with 1 more value at the given index, all values beyond are moved one index forward
      See Also:
        `withAppendedValue(byte)`

    - #### withAppendedValue

          @NotNull
          default ByteIndexable withAppendedValue(byte value)

      Create a view with of this indexable with another value added at the end. Note that this is not efficient, but handy in certain situations where only 1 or a few items are added.
      Parameters:
        `value` - value to add
      Returns:
        indexable view of this indexable, with the given value added at the end, so size is larger by 1
      See Also:
        `withInsertedValueAt(int, byte)`

    - #### withExchangedValueAt

          @NotNull
          default ByteIndexable withExchangedValueAt(int index,
                                                              byte value)

      Create a view of this byte indexable with an exchanged value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are exchanged. Use `ExpandableIntIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable could lead to unexpected results when using the returned indexable!

      Parameters:
        `index` - index where the element is exchanged, hiding the current element. (Pythonesque)
        `value` - exchanged value at that index
      Returns:
        a view of this indexable with 1 more element at the given index, all elements beyond are moved one index forward

    - #### withRemovedValueAt

          @NotNull
          default ByteIndexable withRemovedValueAt(int index)

      Create a view of this indexable with one value removed. Note that this is not efficient, but handy in certain situations where only one or a few values are removed.
      Parameters:
        `index` - index of the removed value (Pythonesque)
      Returns:
        a view of this indexable where the value at the given index is removed

    - #### viewOp

          @NotNull
          default ByteIndexable viewOp(@NotNull
                                                ByteOperator1 op)

      View this byte indexable transformed by an operator.
      Parameters:
        `op` - transforming operator
      Returns:
        view of this indexable with transformed values

    - #### viewAsDouble

          @NotNull
          default DoubleIndexable viewAsDouble()

      View this byte integer indexable as a double indexable. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a double indexable view of this indexable

    - #### viewAsFloat

          @NotNull
          default FloatIndexable viewAsFloat()

      View this byte integer indexable as a float indexable. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a float indexable view of this indexable

    - #### viewAsLong

          @NotNull
          default LongIndexable viewAsLong()

      View this byte integer indexable as a long integer indexable. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsUnsignedLong

          @NotNull
          default LongIndexable viewAsUnsignedLong()

      View this byte integer indexable as an unsigned long integer indexable. This will assume that the values of this indexable don't have a sign bit and range from 0 to 255. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsInt

          @NotNull
          default IntIndexable viewAsInt()

      View this byte integer indexable as an integer indexable. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsUnsignedInt

          @NotNull
          default IntIndexable viewAsUnsignedInt()

      View this byte integer indexable as an unsigned integer indexable. This will assume that the values of this indexable don't have a sign bit and range from 0 to 255. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsShort

          @NotNull
          default ShortIndexable viewAsShort()

      View this byte integer indexable as a short integer indexable. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a byte integer indexable view of this indexable

    - #### viewAsUnsignedShort

          @NotNull
          default ShortIndexable viewAsUnsignedShort()

      View this byte integer indexable as an unsigned short integer indexable. This will assume that the values of this indexable don't have a sign bit and range from 0 to 255. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a byte integer indexable view of this indexable

    - #### withSwappedValuesAt

          @NotNull
          default ByteIndexable withSwappedValuesAt(int index1,
                                                             int index2)

      Create a view of this byte indexable with two values swapped. Note that this is not efficient, but handy in certain situations where only a few items are swapped.
      Parameters:
        `index1` - index of the first value (Pythonesque)
        `index2` - index of the second value (Pythonesque)
      Returns:
        a view of this indexable where the first and second value have exchanged places

    - #### rotated

          @NotNull
          default ByteIndexable rotated(int steps)

      Get a rotated view of this byte indexable. The returned indexable will show this indexable with rotated indexes. A positive `steps` will rotate left, i.e. any index will be accessed as if the number of steps is added before extraction (modulo length). E.g. a rotation of `-1` will return the last element when index `0` is requested, and the first element for index `1`.
      Parameters:
        `steps` - steps to rotate
      Returns:
        rotated view of this indexable, use `frozen()` to create an indexable which no longer depends on this one

    - #### viewAsBoolean

          @NotNull
          default BooleanIndexable viewAsBoolean(@NotNull
                                                          BytePredicate1 convert)

      View this indexable as a boolean indexable while using a conversion for each value.

      Use `frozen()` on the result to decouple it from this indexable.

      Parameters:
        `convert` - converter applied to each value of this indexable before it is returned from the resulting indexable
      Returns:
        boolean indexable view of this indexable

    - #### viewList

          @NotNull
          static ByteIndexable.Base viewList(@NotNull
                                                      java.util.List<? extends java.lang.Number> list)

      View a list as an Indexable. This requires a list of non-null numbers as a base.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static ByteIndexable.Base viewList(@NotNull
                                                      java.util.List<? extends java.lang.Number> list,
                                                      byte nullValue)

      View a list as an Indexable. This allows to provide a fallback for null elements in the list.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
        `nullValue` - value returned for `null` elements in the list
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static <T> ByteIndexable.Base viewList(@NotNull
                                                          java.util.List<T> list,
                                                          @NotNull
                                                          ToByteFunction<? super T> extractor)

      View a generic list as a double indexable.
      Type Parameters:
        `T` - element type of list
      Parameters:
        `list` - generic list
        `extractor` - extractor function which extracts a double from the elements of `list`
      Returns:
        a double indexable view of `list`

    - #### viewIndexable

          @NotNull
          static ByteIndexable.Base viewIndexable(@NotNull
                                                           Indexable<? extends java.lang.Number> indexable)

      View a generic Number indexable as byte indexable.
      Parameters:
        `indexable` - generic indexable with Number elements, required to have only non-null elements
      Returns:
        byte indexable view

    - #### viewIndexable

          @NotNull
          static ByteIndexable.Base viewIndexable(@NotNull
                                                           Indexable<? extends java.lang.Number> indexable,
                                                           byte nullFallback)

      View a generic Number indexable as byte indexable.
      Parameters:
        `indexable` - generic indexable with Number elements
        `nullFallback` - fallback for `null` elements
      Returns:
        byte indexable view

    - #### viewIndexable

          @NotNull
          static <T> ByteIndexable.Base viewIndexable(@NotNull
                                                               Indexable<T> indexable,
                                                               @NotNull
                                                               ToByteFunction<? super T> extractor)

      View a generic indexable as a byte indexable.
      Type Parameters:
        `T` - element type of indexable
      Parameters:
        `indexable` - generic indexable
        `extractor` - extractor function which extracts a byte from the elements of `indexable`
      Returns:
        a byte indexable view of `indexable`

    - #### viewNumberArray

          @NotNull
          static ByteIndexable.Base viewNumberArray(@NotNull
                                                             java.lang.Number... array)

      View a Number array as an Indexable. To view only part of the array use `subSet(int, int)`.
      Parameters:
        `array` - array used as base, required to hold only non-null values
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static ByteIndexable.Base viewArray(@NotNull
                                                       byte... array)

      View a byte array as an Indexable. To view only part of the array use `viewArray(byte[], int, int)`.
      Parameters:
        `array` - array used as base
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static ByteIndexable.Base viewArray(@NotNull
                                                       byte[] array,
                                                       int start,
                                                       int length)

      View part of a byte array as an Indexable.
      Parameters:
        `array` - array used as base
        `start` - index of first byte to use from the array
        `length` - number of elements to use from the array
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static <T> ByteIndexable.Base viewArray(@NotNull
                                                           T[] array,
                                                           @NotNull
                                                           ToByteFunction<? super T> valueExtract)

      View an object array as a byte indexable.
      Type Parameters:
        `T` - array element type
      Parameters:
        `array` - viewed array
        `valueExtract` - converter from array elements to the byte values of this indexable
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### singleton

          @NotNull
          static ByteIndexable.Base singleton(byte value)

      View a single byte value as a byte indexable of size 1.
      Parameters:
        `value` - single value
      Returns:
        indexable with one value

    - #### init

          @NotNull
          static ByteIndexable.Base init(int size,
                                                  byte value)

      Get a byte indexable of a given size which always returns the same value.
      Parameters:
        `size` - size of the returned indexable
        `value` - value returned for each element
      Returns:
        indexable of size `size` with always the same element

    - #### viewByIndex

          @NotNull
          static ByteIndexable.Base viewByIndex(int size,
                                                         @NotNull
                                                         IntToByteFunction1 producer)

      Get a byte indexable of a given size which returns elements created by index. This will always call the `producer` when an element is requested. Use `frozen()` on the result to create an indexable which avoids this.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        an indexable with the given size which will return elements by calling the `producer`

    - #### initByIndex

          @NotNull
          static ByteIndexable initByIndex(int size,
                                                    @NotNull
                                                    IntToByteFunction1 producer)

      Get a byte indexable of a given size which returns elements created by index. This will call the producer only once for each element during the call of this method, and return the results on later requests.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        indexable with elements initialized by the `producer`
      See Also:
        `viewByIndex(int, IntToByteFunction1)`

    - #### emptyIndexable

          @NotNull
          static ByteIndexable.Base emptyIndexable()

      Get an empty indexable set.
      Returns:
        empty indexable

    - #### toString

          @NotNull
          static java.lang.String toString(@NotNull
                                                    ByteIndexable indexable)

      Create a string representation of the given indexable.
      Parameters:
        `indexable` - indexable
      Returns:
        string representation

    - #### equal

          static boolean equal(@NotNull
                               ByteIndexable indexable1,
                               @NotNull
                               ByteIndexable indexable2)

      Are two byte indexables equal?
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if sizes or values differ

    - #### equal

          static boolean equal(@NotNull
                               ByteIndexable indexable1,
                               @Nullable
                               java.lang.Object indexable2)

      Are two byte indexables equal? This is a convenience method which may be called from implementations for their `Object.equals(Object)` method.
      Parameters:
        `indexable1` - first indexable
        `indexable2` - object expected to be an indexable itself
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if the second object is not an indexable, of if sizes or values differ

    - #### compare

          static int compare(@NotNull
                             ByteIndexable indexable1,
                             @NotNull
                             ByteIndexable indexable2)

      Compare two byte indexables. This compares the two indexable lexically element by element until either the first difference is found (smaller of the two values define the lower indexable) or the end of one is met (shorter indexable is less).
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `< 0>` if `indexable1 < indxable2`, `0` if `indexable1 == indexable2`, or `> 0` if `indexable1 > indexable2`

    - #### compareUnsigned

          static int compareUnsigned(@NotNull
                                     ByteIndexable indexable1,
                                     @NotNull
                                     ByteIndexable indexable2)

      Compare two byte indexables as if they contain unsigned byte values. This compares the two indexable lexically element by element until either the first difference is found (smaller of the two values define the lower indexable) or the end of one is met (shorter indexable is less).
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `< 0>` if `indexable1 < indxable2`, `0` if `indexable1 == indexable2`, or `> 0` if `indexable1 > indexable2`

    - #### hash

          static int hash(@NotNull
                          ByteIndexable indexable)

      Calculate a hashcode for a byte indexable.
      Parameters:
        `indexable` - indexable for which the hash code is required
      Returns:
        hash code for the given indexable

    - #### withCachedHash

          @NotNull
          static ByteIndexable.Base withCachedHash(@NotNull
                                                            ByteIndexable indexable)

      Wrap an indexable with one which caches the hash value. This is useful if indexables are used as hash keys because hash value calculation is expensive.

      The wrapped indexable must not change after it is wrapped, otherwise strange things are expected to happen.

      Parameters:
        `indexable` - wrapped indexable, must not change
      Returns:
        indexable which forwards most methods to `indexable`, but also provides useful implementations for `Object.hashCode()`, `Object.equals(Object)`, and `Object.toString()`

    - #### fromHexString

          @NotNull
          static ByteIndexable fromHexString(@NotNull
                                                      java.lang.String hexString)

      Get a byte indexable from a string of hexcoded bytes. This converts a string like `"cafebabe"` to a byte indexable with the 4 bytes 0xCA, 0xFE, 0xBA, and 0cBE.
      Parameters:
        `hexString` - string with hexadecimal digits, 2 per byte
      Returns:
        byte indexable
      Throws:
        `java.lang.IllegalArgumentException` - if the string has odd size
        `java.lang.NumberFormatException` - if the string contains characters which doe't appear in hexcadecimal digits
      See Also:
        `bytesFromHexString(String)`

    - #### bytesFromHexString

          @NotNull
          static byte[] bytesFromHexString(@NotNull
                                                    java.lang.String hexString)

      Get a byte array from a string of hexcoded bytes. This converts a string like `"cafebabe"` to a byte array with the 4 bytes 0xCA, 0xFE, 0xBA, and 0cBE.
      Parameters:
        `hexString` - string with hexadecimal digits, 2 per byte
      Returns:
        byte array
      Throws:
        `java.lang.IllegalArgumentException` - if the string has odd size
        `java.lang.NumberFormatException` - if the string contains characters which doe't appear in hexcadecimal digits

    - #### nextMatch

          default int nextMatch(int startIndex,
                                @NotNull
                                BytePredicate1 check)

      Get the next index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### firstMatch

          default int firstMatch(@NotNull
                                 BytePredicate1 check)

      Get the first index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        first index for which the check returns `true`, `-1` if none

    - #### previousMatch

          default int previousMatch(int startIndex,
                                    @NotNull
                                    BytePredicate1 check)

      Get the previous index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### lastMatch

          default int lastMatch(@NotNull
                                BytePredicate1 check)

      Get the last index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        last index for which the check returns `true`, `-1` if none

    - #### frozen

          @NotNull
          default ByteIndexable frozen()

      Get a frozen version of this indexable.

      Often Indexables are used as a view to underlying collections. Although this interface is immutable, the underlying colelction might nevertheless change. This copies the current state of this indexable into an unmodifiable state, and returns an Indexable which is stable in size and will return always the same element for a given index. Beware: it is still possible that any element itself changes when the elements are mutable.

      Calling `frozen()` again on the returned object will just return the object itself, so you can safely call this method more than once.

      Returns:
        frozen version of this Indexable

    - #### isOrdered

          default boolean isOrdered(@NotNull
                                    ByteOrdering order)

      Is this indexable sorted according to the given ordering? This method tests that consecutive elements in this indexable or either ascending or the same, but never descending.

      See isStrictlyOrdered(ByteOrdering) for a stricter alternative.

      Prefer isOrdered() to check for natural ordering because it is faster.

      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### isOrdered

          default boolean isOrdered()

      Is this indexable sorted naturally? This method tests that consecutive elements in this indexable or either ascending or the same, but never descending.

      See isStrictlyOrdered() for a stricter alternative.

      Returns:
        `true` if this indexable is sorted naturally
        `false` if not

    - #### isStrictlyOrdered

          default boolean isStrictlyOrdered(@NotNull
                                            ByteOrdering order)

      Is this indexable strictly sorted according to the given ordering? This method tests that consecutive elements in this indexable or strictly ascending or the same, but never descending. See isOrdered(ByteOrdering) for a more relaxed alternative.
      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### isStrictlyOrdered

          default boolean isStrictlyOrdered()

      Is this indexable strictly sorted naturally? This method tests that consecutive elements in this indexable or strictly ascending or the same, but never descending. See isOrdered() for a more relaxed alternative.
      Returns:
        `true` if this indexable is sorted naturally
        `false` if not

    - #### binarySearch

          default int binarySearch(byte value)

      Do a binary search in an indexable ordered in natural ascending order. This requires this indexable to be ordered in `natural ascending order`, i.e. isOrdered(ByteOrdering) has to return `true` for this ordering. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### binarySearch

          default int binarySearch(byte value,
                                   @NotNull
                                   ByteOrdering order)

      Do a binary search in an ordered indexable. This requires this indexable to be ordered in non-descending order as defined by the given `order`, i.e. isOrdered(ByteOrdering) has to return `true` for this order. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
        `order` - sort order
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### ordered

          @NotNull
          default MutableByteIndexable ordered(@NotNull
                                                        ByteOrdering order)

      Create a (mutable) byte indexable from the values of this indexable which is ordered as defined by the given ordering.
      Parameters:
        `order` - sort order
      Returns:
        independent int indexable with sorted values

    - #### asBase

          @NotNull
          default ByteIndexable.Base asBase()

      Make this byte indexable usable as a class with defined standard Object methods.
      Returns:
        based version of this indexable